#include "descriptor/descriptor.h"
#include <stdio.h>

int main(void) {

			// ELEMENTI DELLA SCENA

	ITEM scene;

	ITEM C130;

	ITEM Luce01,Luce02;

	ITEM piano_scrivania,piedistallo,piede01,piede02,piede03,piede04,gamba01,gamba02,gamba03,gamba04;

	ITEM interruttore,lampada,base_lampada01,base_lampada02,asta01,asta02,giuntura01,giuntura02;

	ITEM mozzo01,elica0_1,elica0_2,elica0_3,elica0_4;

	ITEM mozzo02,elica1_1,elica1_2,elica1_3,elica1_4;

	ITEM mozzo03,elica2_1,elica2_2,elica2_3,elica2_4;

	ITEM mozzo04,elica3_1,elica3_2,elica3_3,elica3_4;

	ITEM filtro,siga,posacenere;

	ITEM punta_serbatoio, punta_serbatoio2, attacco_serbatoio;

	ITEM punta_serbatoio_b, punta_serbatoio2_b, attacco_serbatoio_b;

	ITEM scrivania, eliche01, eliche02, eliche03, eliche04, serbatoio01, serbatoio02, c130, motore1, motore2,motore3,motore4,stanza;

	ITEM carlinga01,carlinga02,coda,muso_laterale2,muso_laterale,finestrino01,finestrino02,finestrino03,ala_interna,ala_long01,ala_long02,ala_short01,ala_short02,imp01,imp02,imp_dx,imp_dx_ex,imp_sx,imp_sx_ex;

	ITEM m1,m2,m3,m4;

	ITEM m11,m22,m33,m44;

	ITEM m111,m222,m333,m444;

	ITEM m1111,m2222,m3333,m4444;

	ITEM scatola,ripiano_scatola,ripiano_scatola2,ripiano_scatola3,ripiano_scatola4;

	ITEM parete_ant,parete_dx,parete_post,parete_sx,pavimento,quadro,superficie_quadro;


			// ATTRIBUTI

	ITEM	legno,carta,metallo,intonaco,plastica,azzurro,metallo2,giallo,nero,plastica2,parquet,grigio,bianco;


			//DEFINIZIONE LUCI

	set_background(0.675,0.855,0.953,TRUE);
	set_ambient_light(0.9,0.9,0.9,2.5);
	Luce01 = create_point_light(8.888,0.135,11.059,1,1,1,1,1000, "Luce01");
	Luce02 = create_warn_light(-0.128,-1.240,1.590,-0.209,0.501,-0.839,1,1,1,2.8,11,0,33.0,0,0.0,0.0,0.0,0.0, "Luce02");

			// ATTRIBUTO Legno

	legno = create_attribute("legno");
	set_color(legno,0.6,0.4,0.3,0.1,0.8);
	set_reflectivity(legno,0.1,100);

			// ATTRIBUTO Carta

	carta = create_attribute("carta");
	set_color(carta,0.63,0.64,0.60,0.05,0.22);
	set_reflectivity(carta,0.1,1);

			// ATTRIBUTO Metallo

	metallo = create_attribute("metallo");
	set_color(metallo,0.72,0.72,0.72,0.1,0.449);
	set_reflectivity(metallo,0.2,128);

			// ATTRIBUTO Parquet

	parquet = create_attribute("parquet");
	set_color(parquet,1,0.69,0.4,0.1,0.7);
	set_reflectivity(parquet,0.05,25);

			// ATTRIBUTO Plastica

	plastica = create_attribute("plastica");
	set_color(plastica,0.42,0.47,0.44,0.2,0.45);
	set_reflectivity(plastica,0.15,30);

			// ATTRIBUTO Intonaco

	intonaco = create_attribute("intonaco");
	set_color(intonaco,0.83,0.82,0.8,0.1,0.697);
	set_reflectivity(intonaco,0,12);

			// ATTRIBUTO Azzurro

	azzurro = create_attribute("azzurro");
	set_color(azzurro,0.4,0.69,1,0.05,0.3);
	set_reflectivity(azzurro,0,2);

			// ATTRIBUTO Nero

	nero = create_attribute("nero");
	set_color(nero,0,0,0,0.1,0.3);
	set_reflectivity(nero,0.150,30);

			// ATTRIBUTO Giallo

	giallo = create_attribute("giallo");
	set_color(giallo,0.84,0.65,0.43,0,1);
	set_reflectivity(giallo,0,2);

			// ATTRIBUTO Plastica2

	plastica2 = create_attribute("plastica2");
	set_color(plastica2,0.64,0.6,0.50,0.1,0.3);
	set_reflectivity(plastica2,0.15,30);

			// ATTRIBUTO Metallo2

	metallo2 = create_attribute("metallo2");
	set_color(metallo2,0.72,0.72,0.72,0.1,0.9);
	set_reflectivity(metallo2,0.5,128);

			// ATTRIBUTO Grigio

	grigio = create_attribute("grigio");
	set_color(grigio,0.20,0.24,0.20,0.24,0.20);
	set_reflectivity(grigio,0.15,30);

			// ATTRIBUTO Grigio

	bianco = create_attribute("bianco");
	set_color(bianco,1.0,1.0,1.0,0.0,1.0);
	set_reflectivity(bianco,0.0,2);

			// SCRIVANIA

	piano_scrivania = read_nurbs("piano_scrivania.db");
	piedistallo = read_nurbs("piedistallo.db");
	gamba01 = read_nurbs("gamba01.db");
	piede01 = read_nurbs("piede01.db");
	gamba02 = read_nurbs("gamba02.db");
	piede02 = read_nurbs("piede02.db");
	gamba03 = read_nurbs("gamba03.db");
	piede03 = read_nurbs("piede03.db");
	gamba04 = read_nurbs("gamba04.db");
	piede04 = read_nurbs("piede04.db");

	set_attribute(piano_scrivania, legno);
	set_domain_texture(piano_scrivania, legno, "textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);
	set_attribute(piedistallo, metallo);
	set_attribute(gamba01, legno);
	set_domain_texture(gamba01, legno, "textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);
	set_attribute(piede01, legno);
	set_domain_texture(piede01, legno, "textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);
	set_attribute(gamba02, legno);
	set_domain_texture(gamba02, legno, "textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);
	set_attribute(piede02, legno);
	set_domain_texture(piede02, legno, "textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);
	set_attribute(gamba03, legno);
	set_domain_texture(gamba03, legno, "textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);
	set_attribute(piede03, legno);
	set_domain_texture(piede03, legno, "textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);
	set_attribute(gamba04, legno);
	set_domain_texture(gamba04, legno, "textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);
	set_attribute(piede04, legno);
	set_domain_texture(piede04, legno, "textures/venature.hr",0.01,0.99,0.01,0.99,1,0.2,0.3);

	scrivania = create_list(piano_scrivania, "scrivania");
	scrivania = insert_in_list(scrivania,piedistallo);
	scrivania = insert_in_list(scrivania,gamba01);
	scrivania = insert_in_list(scrivania,piede01);
	scrivania = insert_in_list(scrivania,gamba02);
	scrivania = insert_in_list(scrivania,piede02);
	scrivania = insert_in_list(scrivania,gamba03);
	scrivania = insert_in_list(scrivania,piede03);
	scrivania = insert_in_list(scrivania,gamba04);
	scrivania = insert_in_list(scrivania,piede04);
	set_translate(piedistallo,0.0,0.6,-0.02);
	set_translate(scrivania,-0.6,0.0,0.0);

			// LAMPADA

	lampada = read_obj("lampada.obj", "lampada");
	set_attribute(lampada,metallo);
	set_translate(piedistallo,0.0,0.0,0.01);
	set_translate(lampada,-0.6,0.0,-0.0375);
	set_z_rotate(lampada,23,1);

			// ELICHE01

	mozzo01 = read_nurbs("mozzo01.db");
	elica0_1 = read_nurbs("elica0_1.db");
	elica0_2 = read_nurbs("elica0_2.db");
	elica0_3 = read_nurbs("elica0_3.db");
	elica0_4 = read_nurbs("elica0_4.db");

	set_attribute(mozzo01, nero);
	set_attribute(elica0_1, grigio);
	set_attribute(elica0_2, grigio);
	set_attribute(elica0_3, grigio);
	set_attribute(elica0_4, grigio);

	eliche01 = create_list(mozzo01, "eliche01");
	eliche01 = insert_in_list(eliche01,elica0_1);
	eliche01 = insert_in_list(eliche01,elica0_2);
	eliche01 = insert_in_list(eliche01,elica0_3);
	eliche01 = insert_in_list(eliche01,elica0_4);
	set_z_rotate(eliche01,60,1);
	set_scale(eliche01,0.07,0.07,0.07);
	set_translate(eliche01,-0.72,-0.125,0.63);


			// ELICHE02

	mozzo02 = read_nurbs("mozzo02.db");
	elica1_1 = read_nurbs("elica1_1.db");
	elica1_2 = read_nurbs("elica1_2.db");
	elica1_3 = read_nurbs("elica1_3.db");
	elica1_4 = read_nurbs("elica1_4.db");

	set_attribute(mozzo02, nero);
	set_attribute(elica1_1, grigio);
	set_attribute(elica1_2, grigio);
	set_attribute(elica1_3, grigio);
	set_attribute(elica1_4, grigio);

	eliche02 = create_list(mozzo02, "eliche02");
	eliche02 = insert_in_list(eliche02,elica1_1);
	eliche02 = insert_in_list(eliche02,elica1_2);
	eliche02 = insert_in_list(eliche02,elica1_3);
	eliche02 = insert_in_list(eliche02,elica1_4);
	set_z_rotate(eliche02,60,1);
	set_scale(eliche02,0.07,0.07,0.07);
	set_translate(eliche02,-0.66,0.040,0.63);


			// ELICHE03

	mozzo03 = read_nurbs("mozzo03.db");
	elica2_1 = read_nurbs("elica2_1.db");
	elica2_2 = read_nurbs("elica2_2.db");
	elica2_3 = read_nurbs("elica2_3.db");
	elica2_4 = read_nurbs("elica2_4.db");

	set_attribute(mozzo03, nero);
	set_attribute(elica2_1, grigio);
	set_attribute(elica2_2, grigio);
	set_attribute(elica2_3, grigio);
	set_attribute(elica2_4, grigio);

	eliche03 = create_list(mozzo03, "eliche03");
	eliche03 = insert_in_list(eliche03,elica2_1);
	eliche03 = insert_in_list(eliche03,elica2_2);
	eliche03 = insert_in_list(eliche03,elica2_3);
	eliche03 = insert_in_list(eliche03,elica2_4);
	set_z_rotate(eliche03,60,1);
	set_scale(eliche03,0.07,0.07,0.07);
	set_translate(eliche03,-0.66,0.05,0.63);

			// ELICHE04

	mozzo04 = read_nurbs("mozzo04.db");
	elica3_1 = read_nurbs("elica3_1.db");
	elica3_2 = read_nurbs("elica3_2.db");
	elica3_3 = read_nurbs("elica3_3.db");
	elica3_4 = read_nurbs("elica3_4.db");

	set_attribute(mozzo04, nero);
	set_attribute(elica3_1, grigio);
	set_attribute(elica3_2, grigio);
	set_attribute(elica3_3, grigio);
	set_attribute(elica3_4, grigio);

	eliche04 = create_list(mozzo04, "eliche04");
	eliche04 = insert_in_list(eliche04,elica3_1);
	eliche04 = insert_in_list(eliche04,elica3_2);
	eliche04 = insert_in_list(eliche04,elica3_3);
	eliche04 = insert_in_list(eliche04,elica3_4);
	set_z_rotate(eliche04,60,1);
	set_scale(eliche04,0.07,0.07,0.07);
	set_translate(eliche04,-0.54,0.180,0.63);


			// POSACENERE

	posacenere = read_nurbs("posacenere.db");
	siga = read_nurbs("siga.db");
	filtro = read_nurbs("filtro.db");

	set_attribute(posacenere, metallo2);
	set_attribute(siga, bianco);
	set_attribute(filtro, giallo);

	posacenere = create_list(posacenere, "posacenere");
	posacenere = insert_in_list(posacenere,siga);
	posacenere = insert_in_list(posacenere,filtro);
	set_scale(posacenere,0.13,0.13,0.13);
	set_translate(posacenere,-0.5,-1.7,0.375);

			// SERBATOIO1

	serbatoio01 = read_obj("serbatoio.obj", "serbatoio01");
	set_attribute(serbatoio01,plastica2);
	set_scale(serbatoio01,0.07,0.07,0.07);
	set_translate(serbatoio01,-0.30,0.8,0.67);
	set_z_rotate(serbatoio01,60,1);

			// SERBATOIO2

	serbatoio02 = read_obj("serbatoio_b.obj", "serbatoio02");
	set_attribute(serbatoio02,plastica2);
	set_scale(serbatoio02,0.07,0.07,0.07);
	set_translate(serbatoio02,-0.30,0.8,0.67);
	set_z_rotate(serbatoio02,60,1);

			// C-130

	carlinga01 = read_nurbs("carlinga01.db");
	carlinga02 = read_nurbs("carlinga02.db");
	coda = read_nurbs("coda.db");
	imp01 = read_nurbs("imp01.db");
	imp02 = read_nurbs("imp02.db");
	imp_dx = read_nurbs("imp_dx.db");
	imp_dx_ex = read_nurbs("imp_dx_ex.db");
	imp_sx = read_nurbs("imp_sx.db");
	imp_sx_ex = read_nurbs("imp_sx_ex.db");
	ala_long01 = read_nurbs("ala_long01.db");
	ala_short01 = read_nurbs("ala_short01.db");
	ala_long02 = read_nurbs("ala_long02.db");
	ala_short02 = read_nurbs("ala_short02.db");
	ala_interna = read_nurbs("ala_interna.db");
	muso_laterale = read_nurbs("muso_laterale.db");
	muso_laterale2 = read_nurbs("muso_laterale2.db");
	finestrino01 = read_nurbs("finestrino01.db");
	finestrino02 = read_nurbs("finestrino02.db");
	finestrino03 = read_nurbs("finestrino03.db");

	set_attribute(carlinga01, plastica);
	set_domain_texture(carlinga01, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(carlinga02, plastica);
	set_domain_texture(carlinga02, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(coda, plastica);
	set_domain_texture(coda, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(imp01, plastica);
	set_domain_texture(imp01, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(imp02, plastica);
	set_domain_texture(imp02, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(imp_dx, plastica);
	set_domain_texture(imp_dx, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(imp_dx_ex, plastica);
	set_domain_texture(imp_dx_ex, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(imp_sx, plastica);
	set_domain_texture(imp_sx, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(imp_sx_ex, plastica);
	set_domain_texture(imp_sx_ex, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(ala_long01, plastica);
	set_domain_texture(ala_long01, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(ala_short01, plastica);
	set_domain_texture(ala_short01, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(ala_long02, plastica);
	set_domain_texture(ala_long02, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(ala_short02, plastica);
	set_domain_texture(ala_short02, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(ala_interna, plastica);
	set_domain_texture(ala_interna, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(muso_laterale, plastica);
	set_domain_texture(muso_laterale, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(muso_laterale2, plastica);
	set_domain_texture(muso_laterale2, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_attribute(finestrino01, azzurro);
	set_attribute(finestrino02, azzurro);
	set_attribute(finestrino03, azzurro);

	c130 = create_list(carlinga01, "c130");
	c130 = insert_in_list(c130,carlinga02);
	c130 = insert_in_list(c130,coda);
	c130 = insert_in_list(c130,imp01);
	c130 = insert_in_list(c130,imp02);
	c130 = insert_in_list(c130,imp_dx);
	c130 = insert_in_list(c130,imp_dx_ex);
	c130 = insert_in_list(c130,imp_sx);
	c130 = insert_in_list(c130,imp_sx_ex);
	c130 = insert_in_list(c130,ala_long01);
	c130 = insert_in_list(c130,ala_short01);
	c130 = insert_in_list(c130,ala_long02);
	c130 = insert_in_list(c130,ala_short02);
	c130 = insert_in_list(c130,ala_interna);
	c130 = insert_in_list(c130,muso_laterale);
	c130 = insert_in_list(c130,muso_laterale2);
	c130 = insert_in_list(c130,finestrino01);
	c130 = insert_in_list(c130,finestrino02);
	c130 = insert_in_list(c130,finestrino03);
	set_scale(c130,0.07,0.07,0.07);
	set_translate(c130,-0.30,0.8,0.67);
	set_z_rotate(c130,60,1);

			// MOTORE1

	motore1 = read_obj("motore1.obj", "motore1");
	set_attribute(motore1,plastica);
	set_domain_texture(motore1, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_scale(motore1,0.07,0.07,0.07);
	set_translate(motore1,-0.30,0.8,0.67);
	set_z_rotate(motore1,60,1);

			// MOTORE2

	motore2 = read_obj("motore2.obj", "motore2");
	set_attribute(motore2,plastica);
	set_domain_texture(motore2, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_scale(motore2,0.07,0.07,0.07);
	set_translate(motore2,-0.30,0.8,0.67);
	set_z_rotate(motore2,60,1);

			// MOTORE3

	motore3 = read_obj("motore3.obj", "motore3");
	set_attribute(motore3,plastica);
	set_domain_texture(motore3, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_scale(motore3,0.07,0.07,0.07);
	set_translate(motore3,-0.30,0.8,0.67);
	set_z_rotate(motore3,60,1);

			// MOTORE4

	motore4 = read_obj("motore4.obj", "motore4");
	set_attribute(motore4,plastica);
	set_domain_texture(motore4, plastica, "textures/mimetica.hr",0,1,0,1,0,0.15,0.3);
	set_scale(motore4,0.07,0.07,0.07);
	set_translate(motore4,-0.30,0.8,0.67);
	set_z_rotate(motore4,60,1);


			// SCATOLA

	scatola = read_nurbs("scatola.db");
	ripiano_scatola = read_nurbs("ripiano_scatola.db");
	ripiano_scatola2 = read_nurbs("ripiano_scatola2.db");
	ripiano_scatola3 = read_nurbs("ripiano_scatola3.db");
	ripiano_scatola4 = read_nurbs("ripiano_scatola4.db");

	set_attribute(scatola, carta);
	set_attribute(ripiano_scatola, carta);
	set_domain_texture(ripiano_scatola, carta, "textures/model.hr",0,1,0,1,0,0.2,0.3);
	set_attribute(ripiano_scatola2, carta);
	set_domain_texture(ripiano_scatola2, carta, "textures/italeri.hr",0,1,0,1,0,0.2,0.3);
	set_attribute(ripiano_scatola3, carta);
	set_domain_texture(ripiano_scatola3, carta, "textures/italeri.hr",0,1,0,1,0,0.2,0.3);
	set_attribute(ripiano_scatola4, carta);
	set_domain_texture(ripiano_scatola4, carta, "textures/italeri.hr",0,1,0,1,0,0.2,0.3);

	scatola = create_list(scatola, "scatola");
	scatola = insert_in_list(scatola,ripiano_scatola);
	scatola = insert_in_list(scatola,ripiano_scatola2);
	scatola = insert_in_list(scatola,ripiano_scatola3);
	scatola = insert_in_list(scatola,ripiano_scatola4);
	set_translate(ripiano_scatola,0.0,0.0,0.001);
	set_translate(ripiano_scatola2,0.575,0.575,0.0);
	set_translate(ripiano_scatola3,0.003,-0.003,0.0);
	set_translate(ripiano_scatola4,-0.003,-0.003,0.0);
	set_translate(scatola,-0.6,0.0,0.0);
	set_scale(scatola,1.1,1.1,1.1);

			// STANZA

	parete_dx = read_nurbs("parete_dx.db");
	parete_sx = read_nurbs("parete_sx.db");
	pavimento = read_nurbs("pavimento.db");
	parete_post = read_nurbs("parete_post.db");
	parete_ant = read_nurbs("parete_ant.db");
	quadro = read_nurbs("quadro.db");
	superficie_quadro = read_nurbs("superficie_quadro.db");

	set_attribute(parete_dx, intonaco);
	set_attribute(parete_sx, intonaco);
	set_attribute(parete_ant, intonaco);
	set_attribute(parete_post, intonaco);
	set_attribute(pavimento, intonaco);
	set_domain_texture(pavimento, intonaco, "textures/pavimento.hr",0,1,0,1,1,0.2,0.3);
	set_attribute(quadro, bianco);
	set_attribute(superficie_quadro, bianco);
	set_domain_texture(superficie_quadro, intonaco, "textures/c130.hr",0,1,0,1,0,0.3,0.4);

	stanza = create_list(parete_sx, "stanza");
	stanza = insert_in_list(stanza,parete_dx);
	stanza = insert_in_list(stanza,parete_ant);
	stanza = insert_in_list(stanza,parete_post);
	stanza = insert_in_list(stanza,pavimento);
	stanza = insert_in_list(stanza,quadro);
	stanza = insert_in_list(stanza,superficie_quadro);
	set_translate(stanza,0.0,0.0,0.005);

			// SCENA FINALE

	scene = create_list(scrivania, "scene");
	scene = insert_in_list(scene, piedistallo);
	scene = insert_in_list(scene, lampada);
	scene = insert_in_list(scene, eliche01);
	scene = insert_in_list(scene, eliche02);
	scene = insert_in_list(scene, eliche03);
	scene = insert_in_list(scene, eliche04);
	scene = insert_in_list(scene, posacenere);
	scene = insert_in_list(scene, serbatoio01);
	scene = insert_in_list(scene, serbatoio02);
	scene = insert_in_list(scene, c130);
	scene = insert_in_list(scene, motore1);
	scene = insert_in_list(scene, motore2);
	scene = insert_in_list(scene, motore3);
	scene = insert_in_list(scene, motore4);
	scene = insert_in_list(scene, scatola);
	scene = insert_in_list(scene, stanza);
	save_scene("C130.md","C130",scene);
	return(0);
}
